MAXScript Language Reference > 3ds Max Objects > Node : MAXWrapper > Node Subclasses > GeometryClass : Node > Geometry - mental ray >

# mr_Proxy : GeometryClass

    mr_Proxy - superclass: GeometryClass; super-superclass:node - 18:0 - classID: #(771832789, 331352827)

Value > MAXWrapper > Node > GeometryClass > mr_Proxy

| Geometry Objects - Quick Navigation

The mr_Proxy Geometry Object allows the saving of geometry to file to be used by mental ray directly from disk during rendering. This allows therenderingof very complex scenesusing mental raywithoutkeepingtheactuallygeometry in the 3ds Max scene.

Available in 3ds Max 2009 and higher.

Constructor:

    mr_proxy... mental_ray_Proxy...

Properties

## Source Object

    <mr_Proxy>.SrcGeometry UndefinedClass default: undefined -- node; Source_Geometry

Get/set the Source Geometry object.

    <mr_Proxy>.Write BooleanClass default: false -- boolean; Transient_Write_Flag

Set the write flag to true to save the proxy file.Equivalent to pressing the "Write Object To File..." button.

## Proxy File

    <mr_Proxy>.fileName UndefinedClass default: undefined -- filename; File_Name;

Getthe proxyFileName.

    <mr_Proxy>.Scale Float default: 1.0 -- animatable; float; mrProxyScale

Get/Set theproxyScale value.

## Display

    <mr_Proxy>.Points Integer default: 128 -- integer; Points_to_display; mrProxyScale

Get/Set the number ofpointstorepresent the geometry verticesin the viewport.

    <mr_Proxy>.TrianglesUI Integer default: 0 -- integer; Transient_Triangle_Count

Get the number of triangles stored in the proxy file as shown in the UI.

    <mr_Proxy>.ShowPointCloudBooleanClass default: true -- boolean; Show_Point_Cloud

Get/set the state of the Show Point Cloud checkbox.

    <mr_Proxy>.ShowBBoxBooleanClass default: false -- boolean; Show_Bounding_Box

Get/set the state of the Show Bounding Box checkbox.

## Animation Support

    <mr_Proxy>.Animated BooleanClass default: false -- boolean; Animation

Get/Set the Animation Support > On Frame checkbox state.

    <mr_Proxy>.AnimFrames Integer default: 50-- integer; Animation_Frame_Count

Get/Set the Animation Support > On Frame value.

    <mr_Proxy>.AnimSpeed Float default: 1.0 -- float; Animation_Speed

Get/Set the Animation Speed value.

    <mr_Proxy>.AnimOffset Integer default: 0 -- animatable; integer; Animation_Frame_Offset

Get/Set the Animation Offset value.

    <mr_Proxy>.AnimPingPong BooleanClass default: false -- boolean; Ping_Pong_Replay

Get/Set the state of the Ping-Pong Replay checkbox.

## Internal Properties

    <mr_Proxy>.Flags Integer default: 0 -- integer

Internal flags.

## Write Object To File Dialog

    <mr_Proxy>.SaveSingleObjectPreview BooleanClass default: true -- boolean; Exclude_other_objects_when_generating_Preview

Get/set the state of the Exclude Other Objects checkbox.

    <mr_Proxy>.SaveAutoView BooleanClass default: true -- boolean;The__Preview__image_is_automatically_zoomed_such_that_the_object_is_centered_and_fills_the_image

Get/set the state of the Automatic Zoom Extents checkbox.

mrProxy Interfaces

    Interface:mrProxyInterface

Methods:

    <bool> writeProxyDlg <node>node replace :<bool>

replace default value: false

Opens the mr Proxy Creation dialog (see screenshot above) in preparation to save the specified node. Timing and preview generation options have to be selected manually using the dialog and the creation will start with pressing the OK button.

When replace: is true , the proxy will be aligned to the source and the source will be deleted automatically, effectively replacing the source with the proxy.

When replace: is false (default), the proxy will remain at its original location and the source will not be deleted.

    <void> writeProxy <node>node <filename>fileName zoom:<bool> single:<bool> replace:<bool> animation:<bool> start:<integer> end:<integer>

zoom default value: true

single default value: true

replace default value: false

animation default value: false

start default value: 0

end default value: 0

Writes the specified node to the given filenamewithout using the mr Proxy Creation dialog.

When zoom: is true (default),the saved node's preview thumbnail will be zoomed in automatically.

When zoom: is false , the current view will be used without zooming extents.

When single: is true (default),only thesource will be rendered in the preview. This corresponds to the "Include only Source object in Preview" option in the mrProxy creation dialog and the corresponding . SaveSingleObjectPreview property described above.

When single: is false , only the source will be rendered in the preview. This

When replace: is true , the proxy will be aligned to the source and the source will be deleted automatically, effectively replacing the source with the proxy.

When replace: is false (default), the proxy will remain at its original location and the source will not be deleted.

When animation: is false (default), only the current frame will be written to disk.

When animation: is true and the start: and end: parameters are not specified, the current animation segment will be saved using one file per frame. When animation: is true and both the start and end parameters are specified, the used-defined range will be used instead. If only one of the start: and end: parameters is supplied, no files will be written.

EXAMPLES:
    --The followingcodesavesa boxto a custom file name--on the current frame and replaces the source--with the proxy, effectively deleting theboxand moving--the proxy to its position:theProxy = mrProxy()theBox = Box pos:[10,20,30] lengthsegs:10 widthsegs:10theProxy.writeProxytheBox"c:\\temp\\box01_.mib"replace:true  --The following savesthe existingTeapot01using--one file per frame of the whole animation segment--tothe file name already specifiedintheexisting--mrProxy01 object:$mrProxy01.writeProxy $Teapot01 $mrProxy.filename animation:true